/**************************************
 *   Module:    PINGPARS.C            *
 *  Project:    Anon                  *
 *   Author:    SHG                   *
 *      Date:   August 02             *
 *  Copyright (c) Simon Gamble, 2002  *
 **************************************/
/*
    PINGPARS is a util to parse the output from Windows PING
    and output the min/max/avg values, which will then be picked
    up by some stats monitoring tool (e.g. Cacti/RRDTools).
*/

#include    <stdio.h>
#include    <string.h>
#include    "stdequ.h"

//////////////////////////////////////
// Defines...
//
#define MAX_LINE_LEN    132     /* Maximum length of record line */

//////////////////////////////////////////////////////////////
// Function declerations...
//
u_16    getline(str buffer[], u_16 maxlen);     // Read a line from input

///////////////////////////////////////////////////
// Global variables...
//
char    LineStartLoss[] = "    Packets:";
char    LineStartPings[] = "    Minimum";

/////////////////////////////////////////////////
//  Code starts here....
//

void main(void)
{
    int     PMin, PMax, PAvg, PLoss;
    int     i, len;
    str     line_buf[MAX_LINE_LEN + 1];

    PMin = PMax = PAvg = PLoss = -1;

    while ((len = getline(line_buf, MAX_LINE_LEN)) != 0)
        {
            if (strncmp(LineStartLoss, line_buf, strlen(LineStartLoss)) == 0)
                {
                for (i = 0; line_buf[i] != '('; i++)
                    {
                    if (i >= len)
                        break;
                    }
                sscanf(&line_buf[i], "(%d", &PLoss);
                }
            else if (strncmp(LineStartPings, line_buf, strlen(LineStartPings)) == 0)
                {
                sscanf(line_buf," %*s = %dms, %*s = %dms, %*s = %d", &PMin, &PMax, &PAvg);
                }
        }
    fprintf(stdout,"%d %d %d %d", PMin, PMax, PAvg, PLoss);
}

//////////////////////////////////////////////////////////////////
// Read a line from the input into the supplied buffer. Returns
// the number of characters read (including terminating newline).
//
u_16
getline(str buffer[], u_16 maxlen)
{
    u_16    i;
    s_16    c;

    i = 0;

    while ((--maxlen > 0) && ((c = getc(stdin)) != EOF))
    {
        buffer[i++] = c;
        if (c == '\n')
            break;
    }

    buffer[i] = '\0';
    return(i);
}

